package com.delphigl.dglbenchmark.benchmarks;

import javax.media.opengl.GL;
import javax.media.opengl.glu.GLU;

public class BeginEndBenchmark implements IDglBenchmark {

	/*
	 * (non-Javadoc)
	 * @see com.delphigl.dglbenchmark.benchmarks.IDglBenchmark#getBenchmarkInfos()
	 */
	public String getBenchmarkInfos() {
		// String zusammen bauen:

		String str = "";

		str += "name=glBegin/glEnd Benchmark\n";
		str += "version=1.0\n";
		str += "loops=200";

		return str;
	}

	/**
	 * Gibt einen leeren String zurck, da eine Std. OpenGL 1.0 Implementation bereits ausreicht.
	 */
	public String validateBenchmark(GL gl) {
		return "";
	}

	/**
	 * Rendert 1000 Vierecke in einem Block
	 * 
	 * @param gl
	 */
	public void benchmark_SingleBlock(GL gl) {

		gl.glBegin(GL.GL_QUADS);
		for (int i = 0; i < 1000; i++) {
			gl.glColor3f(1f, 0f, 1f);
			gl.glVertex2i((i % 100) * 5, (i / 100) * 30);

			gl.glColor3f(1f, 0f, 0f);
			gl.glVertex2i((i % 100) * 5, ((i / 100) + 1) * 30);

			gl.glColor3f(0f, 1f, 0f);
			gl.glVertex2i(((i % 100) + 1) * 5, ((i / 100) + 1) * 30);

			gl.glColor3f(0f, 0f, 1f);
			gl.glVertex2i(((i % 100) + 1) * 5, (i / 100) * 30);
		}
		gl.glEnd();
	}

	/**
	 * Rendert 1000 Vierecke in 1000 Blcken
	 * 
	 * @param gl
	 */
	public void benchmark_VieleBloecke(GL gl) {
		
		for (int i = 0; i < 1000; i++) {
			gl.glBegin(GL.GL_QUADS);
			
				gl.glColor3f(1f, 0f, 1f);
				gl.glVertex2i((i % 100) * 5, (i / 100) * 30);
	
				gl.glColor3f(1f, 0f, 0f);
				gl.glVertex2i((i % 100) * 5, ((i / 100) + 1) * 30);
	
				gl.glColor3f(0f, 1f, 0f);
				gl.glVertex2i(((i % 100) + 1) * 5, ((i / 100) + 1) * 30);
	
				gl.glColor3f(0f, 0f, 1f);
				gl.glVertex2i(((i % 100) + 1) * 5, (i / 100) * 30);

			gl.glEnd();
		}
	}

	public void setupBenchmark_VieleBloecke(GL gl) {

		GLU glu = new GLU();

		gl.glClearColor(0.0f, 0.0f, 0.0f, 1.0f);

		gl.glViewport(0, 0, 500, 300);
		gl.glMatrixMode(GL.GL_PROJECTION);
		gl.glLoadIdentity();
		glu.gluOrtho2D(0.0, 500.0, 0.0, 300.0);
		gl.glMatrixMode(GL.GL_MODELVIEW);

		gl.glDisable(GL.GL_LIGHTING);
		gl.glDisable(GL.GL_TEXTURE0);
	}

	public void setupBenchmark_SingleBlock(GL gl) {

		GLU glu = new GLU();

		gl.glClearColor(0.0f, 0.0f, 0.0f, 1.0f);

		gl.glViewport(0, 0, 500, 300);
		gl.glMatrixMode(GL.GL_PROJECTION);
		gl.glLoadIdentity();
		glu.gluOrtho2D(0.0, 500.0, 0.0, 300.0);
		gl.glMatrixMode(GL.GL_MODELVIEW);

		gl.glDisable(GL.GL_LIGHTING);
		gl.glDisable(GL.GL_TEXTURE0);
	}

}
