/**
 * 
 */
package com.delphigl.dglbenchmark.benchmarks;

import javax.media.opengl.GL;
import javax.media.opengl.glu.GLU;

/**
 * @author Kevin Fleischer (aka Flash@DelphiGL.com)
 */
public class StdShadingBenchmark implements IDglBenchmark {


	/*
	 * (non-Javadoc)
	 * @see com.delphigl.dglbenchmark.benchmarks.IDglBenchmark#getBenchmarkInfos()
	 */
	public String getBenchmarkInfos() {
		// String zusammen bauen:

		String str = "";

		str += "name=OpenGL Standard Shading Benchmark\n";
		str += "version=1.0\n";
		str += "loops=200";

		return str;
	}

	/**
	 * Gibt einen leeren String zurck, da eine Std. OpenGL 1.0 Implementation bereits ausreicht.
	 */
	public String validateBenchmark(GL gl) {
		return "";
	}

	/**
	 * Rendert 1000 Vierecke in Flatshading
	 * 
	 * @param gl
	 */
	public void benchmark_FlatShading(GL gl) {

		gl.glShadeModel(GL.GL_FLAT);
		
		gl.glBegin(GL.GL_QUADS);
		for (int i = 0; i < 1000; i++) {
			gl.glColor3f(1f, 0f, 1f);
			gl.glVertex2i((i % 100) * 5, (i / 100) * 30);

			gl.glColor3f(1f, 0f, 0f);
			gl.glVertex2i((i % 100) * 5, ((i / 100) + 1) * 30);

			gl.glColor3f(0f, 1f, 0f);
			gl.glVertex2i(((i % 100) + 1) * 5, ((i / 100) + 1) * 30);

			gl.glColor3f(0f, 0f, 1f);
			gl.glVertex2i(((i % 100) + 1) * 5, (i / 100) * 30);
		}
		gl.glEnd();
	}

	/**
	 * Rendert 1000 Vierecke in Smoothshading
	 * 
	 * @param gl
	 */
	public void benchmark_SmoothShading(GL gl) {

		gl.glShadeModel(GL.GL_SMOOTH);
		
		gl.glBegin(GL.GL_QUADS);
		for (int i = 0; i < 1000; i++) {
			gl.glColor3f(1f, 0f, 1f);
			gl.glVertex2i((i % 100) * 5, (i / 100) * 30);

			gl.glColor3f(1f, 0f, 0f);
			gl.glVertex2i((i % 100) * 5, ((i / 100) + 1) * 30);

			gl.glColor3f(0f, 1f, 0f);
			gl.glVertex2i(((i % 100) + 1) * 5, ((i / 100) + 1) * 30);

			gl.glColor3f(0f, 0f, 1f);
			gl.glVertex2i(((i % 100) + 1) * 5, (i / 100) * 30);
		}
		gl.glEnd();
	}

	public void setupBenchmark_SmoothShading(GL gl) {

		GLU glu = new GLU();

		gl.glClearColor(0.0f, 0.0f, 0.0f, 1.0f);

		gl.glViewport(0, 0, 500, 300);
		gl.glMatrixMode(GL.GL_PROJECTION);
		gl.glLoadIdentity();
		glu.gluOrtho2D(0.0, 500.0, 0.0, 300.0);
		gl.glMatrixMode(GL.GL_MODELVIEW);

		gl.glDisable(GL.GL_LIGHTING);
		gl.glDisable(GL.GL_TEXTURE0);
	}

	public void setupBenchmark_FlatShading(GL gl) {

		GLU glu = new GLU();

		gl.glClearColor(0.0f, 0.0f, 0.0f, 1.0f);

		gl.glViewport(0, 0, 500, 300);
		gl.glMatrixMode(GL.GL_PROJECTION);
		gl.glLoadIdentity();
		glu.gluOrtho2D(0.0, 500.0, 0.0, 300.0);
		gl.glMatrixMode(GL.GL_MODELVIEW);

		gl.glDisable(GL.GL_LIGHTING);
		gl.glDisable(GL.GL_TEXTURE0);
	}
}
